#include "uniTFT.h"

void callbackReceiveData(byte len);

void setup() 
{
  // put your setup code here, to run once:
  //uniTFT.initialize_spi(10,11,11,11,3);
  uniTFT.initialize_i2c(400, 0xDE, 3);
  uniTFT.RegisterCallbackReceive(callbackReceiveData);
  uniTFT.sendDataPacket("\x0C",1); //Send FormFeed (Clear terminal window and set cursor to 1,1)
  uniTFT.sendDataPacket("Text sent by arduino to console\r\n", 33);
}

void loop() 
{
  // put your main code here, to run repeatedly:

}

void callbackReceiveData(byte len)
{
  const byte *rec = uniTFT.receivedData();
  char command[4];
  int retval1, retval2;
  char dataToSend[19] = "#SSC3, \"Button ?\"\n";
  while(len--)
  {
      if(len>3) //Answer at least: ESC + 3 Chars command
      {
        command[0] = *rec++; command[1] = *rec++;command[2] = *rec++; command[3] = *rec++;
        if(command[0] != ESC)
          break;
        if(command[1] == 'T') //Touch return
        {
          if(command[2] == 'Q') //Touch key status
          {
            if(command[3] == 'S') //State of button/switch
            {
              retval1 = *rec++; retval1 |= (int)(*rec++)<<8; //Object-ID
              retval2 = *rec++; retval1 |= (int)(*rec++)<<8; //State (1=unpressed, 2=pressed)
              dataToSend[15]=retval1+'0';
              uniTFT.sendDataPacket(dataToSend, 18);
            }
          }
        }
      }
  }
}

